#include "konsole.h"

#include <stdlib.h>

void konsole_init(Konsole *konsole);
void konsole_neue_personalien(Konsole *konsole);
void konsole_zeige_personalien_nach_index(Konsole *konsole, int index);
void konsole_zeige_personalien_nach_feld(Konsole *konsole, int nth, char *text);

void
konsole_init(Konsole *konsole)
{
  konsole->personalien = personalien_neu();
  konsole->name = NULL;
  konsole->datei = NULL;
}

void
konsole_neue_personalien(Konsole *konsole)
{
  int wert;
  char *zeichenkette;

  /* zerst s'erfassä vo dä Datä */
  printf("enter firstname: \0");
  zeichenkette = (char *) malloc(256 * sizeof(char));
  scanf("%s\0", zeichenkette);
  konsole->personalien->vorname = zeichenkette;

  printf("enter surname: \0");
  zeichenkette = (char *) malloc(256 * sizeof(char));
  scanf("%s\0", zeichenkette);
  konsole->personalien->nachname = zeichenkette;

  printf("enter street: \0");
  zeichenkette = (char *) malloc(256 * sizeof(char));
  scanf("%s\0", zeichenkette);
  konsole->personalien->strasse = zeichenkette;

  printf("enter housenumber: \0");
  scanf("%d\0", &wert);
  konsole->personalien->hausnummer = wert;

  printf("enter city: \0");
  zeichenkette = (char *) malloc(256 * sizeof(char));
  scanf("%s\0", zeichenkette);
  konsole->personalien->ort = zeichenkette;

  printf("enter postcode: \0");
  scanf("%d\0", &wert);
  konsole->personalien->postleitzahl = wert;

  printf("enter email: ");
  zeichenkette = (char *) malloc(256 * sizeof(char));
  scanf("%s\0", zeichenkette);
  konsole->personalien->email = zeichenkette;

  printf("enter telephone number: ");
  scanf("%d\0", &wert);
  konsole->personalien->telefon_nummer = wert;

  /* jetzt chunt s'schrieb vo dä Datä i d'Datei */
  fprintf(konsole->datei, "%s\n\0", konsole->personalien->vorname);
  fprintf(konsole->datei, "%s\n\0", konsole->personalien->nachname);
  fprintf(konsole->datei, "%s\n\0", konsole->personalien->strasse);
  fprintf(konsole->datei, "%d\n\0", konsole->personalien->hausnummer);
  fprintf(konsole->datei, "%s\n\0", konsole->personalien->ort);
  fprintf(konsole->datei, "%d\n\0", konsole->personalien->postleitzahl);
  fprintf(konsole->datei, "%s\n\0", konsole->personalien->email);
  fprintf(konsole->datei, "%d\n\0", konsole->personalien->telefon_nummer);
  fflush(konsole->datei);
}

void
konsole_zeige_personalien_bei_index(Konsole *konsole, int index)
{
  Personalien personalien;
  unsigned int i;

  fseek(konsole->datei, 0, SEEK_SET);
  
  for(i = 0; i < index; i++){
    fscanf(konsole->datei, "%s\n%s\n%s\n%d\n%s\n%d\n%s\n%d\n\0",
           &konsole->personalien->vorname,
           &konsole->personalien->nachname,
           &konsole->personalien->strasse,
           &konsole->personalien->hausnummer,
           &konsole->personalien->ort,
     	   &konsole->personalien->postleitzahl,
    	   &konsole->personalien->email,
    	   &konsole->personalien->telefon_nummer);
  }
}

void
konsole_zeige_personalien_bei_feld(Konsole *konsole, int nth, char *text)
{
  Personalien personalien;
  char *separator = "  -------  ";
  int return_value;

  fseek(konsole->datei, 0, SEEK_SET);
  
  while(!0){
    return_value = fscanf(konsole->datei, "%s\n%s\n%s\n%d\n%s\n%d\n%s\n%d\n\0",
			  &konsole->personalien->vorname,
			  &konsole->personalien->nachname,
			  &konsole->personalien->strasse,
			  &konsole->personalien->hausnummer,
			  &konsole->personalien->ort,
			  &konsole->personalien->postleitzahl,
			  &konsole->personalien->email,
			  &konsole->personalien->telefon_nummer);
    
    switch(nth){
    case 0:
      if(!strcmp(konsole->personalien->vorname, text)){
	fprintf(stdout, "%s\n\0", separator);
	personalien_zeige(konsole->personalien);
	fprintf(stdout, "%s\n\0", separator);
      }
      break;
    case 1:
      if(!strcmp(konsole->personalien->nachname, text)){
	fprintf(stdout, "%s\n\0", separator);
	personalien_zeige(konsole->personalien);
	fprintf(stdout, "%s\n\0", separator);
      }
      break;
    case 2:
      if(!strcmp(konsole->personalien->strasse, text)){
	fprintf(stdout, "%s\n\0", separator);
	personalien_zeige(konsole->personalien);
	fprintf(stdout, "%s\n\0", separator);
      }
      break;
    case 3:
      if(konsole->personalien->hausnummer == atoi(text)){
	fprintf(stdout, "%s\n\0", separator);
	personalien_zeige(konsole->personalien);
	fprintf(stdout, "%s\n\0", separator);
      }
      break;
    case 4:
      if(!strcmp(konsole->personalien->ort, text)){
	fprintf(stdout, "%s\n\0", separator);
	personalien_zeige(konsole->personalien);
	fprintf(stdout, "%s\n\0", separator);
      }
      break;
    case 5:
      if(konsole->personalien->postleitzahl == atoi(text)){
	fprintf(stdout, "%s\n\0", separator);
	personalien_zeige(konsole->personalien);
	fprintf(stdout, "%s\n\0", separator);
      }
      break;
    case 6:
      if(!strcmp(konsole->personalien->email, text)){
	fprintf(stdout, "%s\n\0", separator);
	personalien_zeige(konsole->personalien);
	fprintf(stdout, "%s\n\0", separator);
      }
      break;
    case 7:
      if(konsole->personalien->telefon_nummer == atoi(text)){
	fprintf(stdout, "%s\n\0", separator);
	personalien_zeige(konsole->personalien);
	fprintf(stdout, "%s\n\0", separator);
      }
      break;
    }
  }
}

int
main(int argc, char **argv)
{
  Konsole *konsole;
  char *zeichenkette;
  int wert;

  konsole = (Konsole *) malloc(sizeof(Konsole));
  konsole_init(konsole);

  /*
   * Falls du `gcc` unter Windows vowändisch, söttisch
   * diä folgendi Zeilä uskommentierä, das erlaubt
   * dir mittels scanf än 256 Zeichä lange String uszläsä.
   * Sötteds meh si, passiert än Bufferoverflow und
   * s'Programm stürzt ab! Beachte, das Strings Nullterminiert
   * si mönd!
   * Bufferoverflows werdet däzue vowendet i System izbrechä.
   */
  zeichenkette = (char *) malloc(256 * sizeof(char));


  if(argc == 1){
    konsole->datei = fopen("default\0", "w+\0");
  }else if(argc == 2){
    konsole->datei = fopen(argv, "a+\0");
  }else
    printf("the konsole takes at most 1 argument\n\0");

  while(!0){
    printf("> \0");
    scanf("%256[^\n]%*[^\n]\0", zeichenkette);
    getchar();

    if(!strncmp(zeichenkette, "quit\0", 4))
      break;
    else if(!strncmp(zeichenkette, "new\0", 3))
      konsole_neue_personalien(konsole);
    else if(!strncmp(zeichenkette, "show\0", 4)){
     main0:

      fprintf(stdout, "[0] - index\n\0");
      fprintf(stdout, "[1] - firstname\n\0");
      fprintf(stdout, "[2] - surname\n\0");
      fprintf(stdout, "[3] - street\n\0");
      fprintf(stdout, "[4] - house number\n\0");
      fprintf(stdout, "[5] - city\n\0");
      fprintf(stdout, "[6] - post code\n\0");
      fprintf(stdout, "[7] - email\n\0");
      fprintf(stdout, "[8] - telephone number\n\0");
      fprintf(stdout, "[9] - exit");
      fprintf(stdout, "enter number: \0");

      scanf("%d\n\0", &wert);

      switch(wert){
        case 0:
          fprintf(stdout, "enter index: \0");
          scanf("%d\n\0", &wert);
          konsole_zeige_personalien_bei_index(konsole, wert);
          break;
        case 1:
        case 2:
        case 3:
        case 4:
        case 5:
        case 6:
        case 7:
        case 8:
          fprintf(stdout, "enter search criteria: \0");
          scanf("%s\0", &zeichenkette);
          konsole_zeige_personalien_bei_feld(konsole, wert - 1, zeichenkette);
          break;
        case 9:
          break;
        default:
          fprintf(stdout, "you didn't enter a number between 0 and 9\n\0");
          goto main0;
	  }
    }else
      fprintf(stdout, "enter \"quit\", \"new\" or \"show\"\n");
  }

  fclose(konsole->datei);
  free(konsole->personalien);
  free(konsole);

  return(0);
}
